/*==========================================================================
	Datei:	reents_sama5d3x.c

	reent-Strukturen fr jeden IRQ-Level

	Begonnen:			23.05.2012
	Letzte nderung:	12.10.2013
	Autor:				M.Bhme\HAMEG Chemnitz
===========================================================================*/

/*--- Includes ------------------------------------------------------------*/

#include <reent.h>
#include <IO_SAMA5D3x.h>

#ifdef SYS_WITH_FREERTOS	/* defined in makefile */
#include <portmacro.h>
#endif

/*--- Makros & Konstanten -------------------------------------------------*/

/*--- Type Definitionen ---------------------------------------------------*/

/*--- Prototypen ----------------------------------------------------------*/

/*--- Globals -------------------------------------------------------------*/

// Initialisierung muss man je nach Anzahl der Prioritten aktualisieren!
// Das ist ein enum, daher funktionieren Prprozessor-#if nicht!
static struct _reent	sys_reents0[CPU_IRQ_PRIOR_NO] __attribute__ ((aligned (CPU_CACHE_LINE_LENGTH))) =
{
	_REENT_INIT(sys_reents0[0]),
	_REENT_INIT(sys_reents0[1]),
	_REENT_INIT(sys_reents0[2]),
	_REENT_INIT(sys_reents0[3]),
	_REENT_INIT(sys_reents0[4]),
	_REENT_INIT(sys_reents0[5]),
	_REENT_INIT(sys_reents0[6]),
	_REENT_INIT(sys_reents0[7]),
	_REENT_INIT(sys_reents0[8]),
	_REENT_INIT(sys_reents0[9]),
};

/*--- Funktionen ----------------------------------------------------------*/

struct _reent * sysCall_getreent (unsigned int irqLvl)
{
	struct _reent	*ptr;

#if FREERTOS_REENT_CHANGE_POINTER
	// auf FreeRTOS-Tasklevel den reent-Zeiger aus dem aktuellen Task holen fr (Core A)
	if (irqLvl == CPU_IRQ_PRIOR_SYS && portCurrentTaskReentPtr != NULL)
	{
		return portCurrentTaskReentPtr;
	}
#endif

	if (irqLvl < CPU_IRQ_PRIOR_NO)
	{
		ptr = &sys_reents0[0];

		// die dazugehrige Struktur liefern
		return &ptr[irqLvl];
	}
	// Standard
	return _REENT;
}
